var Connection = require('tedious').Connection
var Request = require('tedious').Request

const config = {
  server: 'DESKTOP-BP4I6KI',
  database: 'SAMPLE',
  options: {
    trustServerCertificate: true
  },
  authentication: {
    type: 'default',
    options: {
        userName: 'test', //update me
        password: 'test'  //update me
    }
},
}
function executeLocalQuery(query,connection, callback){  
   var request = new Request(query, function (err, rowCount) {
    if (err) {
      console.log("ERROR: " + err);
      return "ERROR: " + err;
    }
    connection.close()
  })

  //Default callback
  function noop(data){}

  var dataList = []
  request.on('row', function (columns) {
    dataList.push(columns);
  })

  request.on('doneProc',function (rowCount, more, rows){
    console.log("DONE");
    if(callback){
      callback(dataList)
    }
  })
  connection.execSql(request)
}

module.exports = {
  executeQuery: function(query, callback = null){

    var connection = new Connection(config)
    connection.on('connect', function (err) {
      if (err) {
        console.log("ERROR: " + err);
        return "ERROR: " + err;
      } else { 
        executeLocalQuery(query,connection, callback);
      }
    })
  } 
};
